define([
	"dojo/_base/declare",
	"dojo/_base/lang",
	"dojo/_base/array",
	"thornberry/object/TableManager",
	"thornberry/app/Component/Report/View",
	"thornberry/report/GridView",
	"thornberry/app/Service/AccountsReceivable",
	"thornberry/app/utils"
],function(
	declare,
	lang,
	arrayUtils,
	TableManager,
	ReportView,
	GridView,
	service,
	utils
) {
	return declare(ReportView,{
		title: "Payments/Adjustments",

		defaultToFilterView: false,
		showPresetControl: false,

		controllerProps: {
			createGrid: function() {
				var t = this;
				t.set("gridView",new GridView({
					controller: t,
					title: t.report.displayName
				}));
			}
		},

		getInitialProps: function() {
			return lang.mixin(this.inherited(arguments),{
				reportClass: "Billing.Report.PaymentsAdjustments",
				filters: null
			});
		},

		getPageProps: function() {
			var t = this;
			var selectedIds = t.props.selectedIds;
			var singleSelection = selectedIds.length == 1;

			return lang.mixin(t.inherited(arguments), {
				actions: [
					{ label: "Refresh", onClick: function() {t.controller.gridView.updateGridData(true);} },
					[
						{ label: "View", onClick: function() { t.loadSubView("transaction", { mode: "view" }); }, hidden: !singleSelection },
						{ label: "Edit", onClick: function() { t.loadSubView("transaction", { mode: "edit" }); }, hidden: !singleSelection },
					]
				]
			});
		},

		buildRendering: function() {
			var t = this;
			t.inherited(arguments);
		},

		postCreate: function() {
			var t = this;
			t.inherited(arguments);

			// Force the report initialization to occur when the module preloads the view
			t.invalidateRendering();
		},

		onShow: function() {
			var t = this;
			t.inherited(arguments);
			if (t.firstShow) {
				t.addSubView("transaction", "thornberry/app/Component/AccountsReceivable/TransactionView", function() {
					return {
						objectId: t.props.selectedIds[0],
						onSave: lang.hitch(t,"refreshData")
					};
				} );
			}
		},

		onRowDoubleClick: function(id) {
			console.log(this.getGridData(id));
			this.loadSubView("transaction", { objectId: id, mode: "view" } );
		}
	});
});