define([
    "dojo/_base/declare",
    "thornberry/app/Component/_EditorComponent",
    "thornberry/app/Component/_TableFieldEditorMixin",
    "dijit/_TemplatedMixin",
    "dijit/_WidgetsInTemplateMixin",
    "dojo/text!./Templates/LocationAdjustmentHHVBP.html",
    "dojo/text!./Templates/LocationAdjustmentQRP.html",
    "dojo/_base/lang",
    "dojo/aspect",
    "dijit/form/DateTextbox",
    "dijit/form/NumberTextBox",
    "dijit/form/ValidationTextBox",
    "dijit/form/Form",
    "dijit/form/Button"
],function(
    declare,
    _EditorComponent,
    _TableFieldEditorMixin,
    _TemplatedMixin,
    _WidgetsInTemplateMixin,
    hhvbpTemplate,
    qrpTemplate,
    lang,
    aspect
) {
    return declare([ _EditorComponent,_TableFieldEditorMixin,_TemplatedMixin,_WidgetsInTemplateMixin],{
        layout: "QRP", // or "HHVBP"
        templateString: null,

        getInitialProps: function() {
            return lang.mixin(this.inherited(arguments),{
                onRemove: null,
                onChange: null
            });
        },

        postMixInProperties: function() {
            var t = this;
            t.inherited(arguments);

            var layouts = {
                QRP :   qrpTemplate,
                HHVBP:  hhvbpTemplate
            }
            t.templateString = (layouts[t.layout] ? layouts[t.layout] : layouts["qrpTemplate"]);

            aspect.after(t,"updateModified",function() {
                if (t.props.onChange) {
                    t.props.onChange();
                }
            });
        },

        buildRendering: function() {
            var t = this;
            t.inherited(arguments);
            
            t.addRequirement(null,true);
        },

        _setDisabledAttr: function(value) {
            var t = this;
            t.disabled = value;
            t.removeButton.set("disabled",value);
        },

        _onRemove: function() {
            var t = this;
            if (t.props.onRemove) {
                t.props.onRemove();
            }
        }
    });
});