define([
    "dojo/_base/declare",
    "dojo/_base/lang",
    "thornberry/app/Component/_Component",
    "thornberry/app/Component/_ViewMixin",
    "dijit/_TemplatedMixin",
    "dojo/text!./Templates/ResponseView.html",
    "thornberry/app/utils",
    "thornberry/app/service/NoeNotr"
],function(
    declare,
    lang,
    _Component,
    _ViewMixin,
    _TemplatedMixin,
    template,
    utils,
    service
) {
    return declare([_Component,_ViewMixin,_TemplatedMixin],{
        templateString: template,

        title: "{type} Response",

        id: "",

        getTitle: function() {
            return lang.replace(this.title,this.props);
        },

        getInitialProps: function() {
            return lang.mixin(this.inherited(arguments),{
                type: "",
                id: ""
            });
        },

        getPageProps: function() {
            var t = this;
            return lang.mixin(t.inherited(arguments),{
                content: t.domNode,
                actions: [
                    { label: "Back", onClick: t.props.onCloseView }
                ]
            });
        },

        refreshRendering: function() {
            var t = this;
            t.set("id",t.props.id);
            t.inherited(arguments);
        },

        _setIdAttr: function(value) {
            var t = this;
            if (t.id != value) {
                t.addReadyPromise(service.getResponse(value).then(function(response) {
                    t.rejectedNode.innerHTML = response.rejected ? "Yes" : "No";
                    t.responseNode.innerHTML = response.infoHtml;
                },utils.showMessage));
            }
        }
    });
});