define([
	"dojo/_base/declare",
	"thornberry/serverRequest",
	"thornberry/app/utils",
	"dojo/Deferred"
],function(
	declare,
	serverRequest,
	utils,
	Deferred
) {
	var DASHBOARD_SERVER_CLASS = "Billing.AccountsReceivable.DashboardService";
	var SERVER_CLASS = "Billing.AccountsReceivable.Service";

	var Service = declare(null, {
		getDashboardData: function() {
			return serverRequest(DASHBOARD_SERVER_CLASS, "GetData", { userId: utils.environment.getUserId() });
		},
		updateAccountStatus: function(accountIds, status) {
			return serverRequest(SERVER_CLASS, "UpdateAccountStatus", {
				accountIds: accountIds,
				status: status
			});
		},
		getAccount: function(value) {
			return serverRequest(SERVER_CLASS, "GetAccount", value);
		},
		editAccount: function(value) {
			return serverRequest(SERVER_CLASS, "EditAccount", value);
		},
		savePrePayment: function(value) {
			return serverRequest(SERVER_CLASS, "SavePrePaymentJson", value);
		},
		postTransaction: function(value) {
			return serverRequest(SERVER_CLASS, "PostTransaction", value);
		},
		getTransaction: function(value) {
			return serverRequest(SERVER_CLASS, "GetTransaction", value);
		},
		transferBalance: function(value) {
			return serverRequest(SERVER_CLASS, "TransferBalance", value);
		}
	},true);
	return new Service(); // Singleton
});