define([
	"dojo/_base/declare",
	"dojo/_base/array",
	"dojo/_base/lang",
	"dijit/_WidgetBase",
	"dojo/dom-construct"
],function(
	declare,
	arrayUtils,
	lang,
	_WidgetBase,
	domConstruct
) {
	return declare([_WidgetBase],{
		data: "",
		
		_setDataAttr: function(data) {
			var t = this;
			t.data = data;
			if (!t.domNode) {
				t.domNode = domConstruct.create("div");
			} else {
				domConstruct.empty(t.domNode);
			}

			var tableNode = domConstruct.toDom("<table class='tbl-data-std tbl-alt'></table>");

			var rowTemplate = "";
			var headerNode = domConstruct.create("tr");
			arrayUtils.forEach(data.structure, function(column) {
				// Build table header
				headerNode.appendChild(domConstruct.toDom(lang.replace("<th>{name}</th>", column)));

				// Build template for rows
				//rowTemplate += lang.replace("<td>\{{id}\}</td>", column);
				rowTemplate += "<td>{" + column.id + "}</td>";
			});
			tableNode.appendChild(domConstruct.create("thead").appendChild(headerNode));

			var bodyNode = domConstruct.create("tbody");
			arrayUtils.forEach(data.data, function(row) {
				bodyNode.appendChild(domConstruct.toDom(lang.replace("<tr>" + rowTemplate + "</tr>", row)));
			});
			tableNode.appendChild(bodyNode);
			t.domNode.appendChild(tableNode);
		}
	});
});